unit RessFils;

{Freeware by Mezou Prod

For D1 and D2.

You can use, distribute and modify, 
just tell me what you do with this component.

Not Warranty, This component is provided "As is".

Quick Use:
In a form, Put a MainMenu, a TRecentFile, an OpenDialiog and a Button.

In TForm1.Button1Click(Sender: TObject) Write:

OpenDialog1.FileName:='';
   if OpenDialog1.Execute
   then RecentFiles1.AddFile(OpenDialog1.FileName);

Run,
Push the Button, Choose a File and see the MainMenu.

For more, See and TRY RF_Demo.dpr.



JJ Rou

   EMail: jean-jacques.roue@worldonline.fr
   Web: None}

interface

uses
  {$IFDEF WIN32}
  Windows,
  {$ELSE}
  WinTypes, WinProcs,
  {$ENDIF}
  SysUtils,Classes,
  Forms,Menus,IniFiles;

type
  TRFCliquer=procedure(FileName:String) of Object;
  TRecentFiles = class(TComponent)

  private
  { Dclarations prives }
  RFRecentFiles:TStringList;
  RFIni:TiniFile;
  RFIniName,RFIniSection,
  RFIniVar:String;
  RFAutoSave:Boolean;
  RFClick:TRFCliquer;

  {Les items.}
  RFMenuProp:TMainMenu;
  RFAuCasOu:TMenuItem;
  RFSepar1:TMenuItem;
  RFRecent1:TMenuItem;
  RFRecent2:TMenuItem;
  RFRecent3:TMenuItem;
  RFRecent4:TMenuItem;
  RFRecent5:TMenuItem;

  {}
  RFSubMenu:Byte;


  {Click Sur un Item.}
  procedure RFExec(Sender:TObject);
  {Attribution du Menu Principal.}
  procedure Loaded; override;
  {Ecire dans les Items ce qu'il faut.}
  Procedure RFFaireLeMenu;

  {Nom de la Section du fichier Ini.}
  Procedure SetRFIniSection(Value:String);
  {Nom de la VARIABLE du fichier Ini.}
  Procedure SetRFIniVar(Value:String);


  protected
    { Dclarations protges }

  public
    { Dclarations publiques }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    {Mthodes:}
    {Nom du fichier INI.}
    Procedure IniName(Value:String);
    {Ajouter un nom de fichier dans le Menu}
    Procedure AddFile(TheFile:String);
    {Enregistrer les noms de fichiers dans le fichier INI.}
    Procedure SaveNames;

  published
    { Dclarations publies }
  {Fichier Ini:}
  {Titre de la section d'enregistrement.}
  Property IniSection:String read RFIniSection Write SetRFIniSection;
  {Nom de la VARIABLE dans le fichier Ini.}
  Property IniVar:String read RFIniVar Write SetRFIniVar;
  {Enregistrement AUTOMATIQUE des fichiers rcents  la Destruction de la form.}
  Property AutoSave:Boolean Read RFAutoSave Write RFAutoSave;
  {Evnement OnClick}
  Property OnCliquer:TRFCliquer read RFClick Write RFClick;
  {Numro du SubMenu qui recevra les fichiers Rcents.}
  Property SubMenu:Byte read RFSubmenu Write RFSubmenu;

  end;

procedure Register;

implementation

constructor TRecentFiles.Create( AOwner : TComponent );
begin
   inherited Create(AOwner);
RFRecentFiles:=TStringList.Create;
RFMenuProp:=Nil;
RFIniName:='';
RFIniSection:='Recents';
RFIniVar:='File';
RFAutoSave:=True;
RFSubMenu:=0;

end;

destructor TRecentFiles.Destroy;
begin
   if Not(csDesigning in componentstate)
   and(RFMenuProp<>Nil)then
   begin
      If (RFIniName<>'')then
      begin
         if RFAutoSave
         then SaveNames;
      RFIni.Free;
      end;
   end;
RFRecentFiles.Free;
   inherited Destroy;

end;

Procedure TRecentFiles.SetRFIniSection(Value:String);
begin
   if Value=RFIniSection then Exit;
   if Value=''
   then Value:='Recents';
RFIniSection:=Value;
end;

Procedure TRecentFiles.SetRFIniVar(Value:String);
begin
   if Value=RFIniVar then Exit;
   if Value=''
   then Value:='File';
RFIniVar:=Value;
end;



{Attribution du Menu Principal...
ET AJOUT des Items Vides.}
procedure TRecentFiles.Loaded;
begin
RFMenuProp:=TForm(Owner).Menu;
   if csDesigning in componentstate then exit;
   if RFMenuProp=Nil then Exit;
   {Si le 1er Item du menu n'a pas t crit...}
   if RFMenuProp.Items.Count=0 then
   begin
   RFAuCasOu:=TMenuItem.Create(RFMenuProp);
   RFAuCasOu.Caption:='Fichiers Rcents';
   RFMenuProp.Items.Add(RFAuCasOu);
   end;
   {Choisir le Sous Menu.}
   If Submenu>RFMenuProp.Items.Count-1
   then RFSubmenu:=0
   else RFSubmenu:=Submenu;
{Le Sparateur.}
RFSepar1:=TMenuItem.Create(RFMenuProp);
RFSepar1.Caption:='-';
RFSepar1.Visible:=False;
RFMenuProp.Items[RFSubmenu].Insert(RFMenuProp.Items[RFSubmenu].count,RFSepar1);
{les 5 Items.}
RFRecent1:=TMenuItem.Create(RFMenuProp);
RFRecent1.Caption:='';
RFRecent1.Visible:=False;
RFRecent1.Tag:=0;
RFRecent1.OnClick:=RFExec;
RFMenuProp.Items[RFSubmenu].Insert(RFMenuProp.Items[RFSubmenu].count,RFRecent1);
RFRecent2:=TMenuItem.Create(RFMenuProp);
RFRecent2.Caption:='';
RFRecent2.Visible:=False;
RFRecent2.Tag:=1;
RFRecent2.OnClick:=RFExec;
RFMenuProp.Items[RFSubmenu].Insert(RFMenuProp.Items[RFSubmenu].count,RFRecent2);
RFRecent3:=TMenuItem.Create(RFMenuProp);
RFRecent3.Caption:='';
RFRecent3.Visible:=False;
RFRecent3.Tag:=2;
RFRecent3.OnClick:=RFExec;
RFMenuProp.Items[RFSubmenu].Insert(RFMenuProp.Items[RFSubmenu].count,RFRecent3);
RFRecent4:=TMenuItem.Create(RFMenuProp);
RFRecent4.Caption:='';
RFRecent4.Visible:=False;
RFRecent4.Tag:=3;
RFRecent4.OnClick:=RFExec;
RFMenuProp.Items[RFSubmenu].Insert(RFMenuProp.Items[RFSubmenu].count,RFRecent4);
RFRecent5:=TMenuItem.Create(RFMenuProp);
RFRecent5.Caption:='';
RFRecent5.Visible:=False;
RFRecent5.Tag:=4;
RFRecent5.OnClick:=RFExec;
RFMenuProp.Items[RFSubmenu].Insert(RFMenuProp.Items[RFSubmenu].count,RFRecent5);
end;

{Attribuer le NOM du fichier INI.}
Procedure TRecentFiles.IniName(Value:String);
Var
RFx:Integer;
Begin
   if Value=RFIniName then Exit;
RFIniName:=Value;
   if csDesigning in componentstate then exit;
   if RFMenuProp=Nil then Exit;
{Cration du fichier INI.}
RFIni:=TiniFile.Create(RFIniName);
{Chercher les derniers Fichiers utiliss.}
   For RFx:=0 to 4 do
   begin
      {Si le fichier existe TOUJOURS; on l'ajoute.}
      if FileExists(RFIni.ReadString(RFIniSection,RFIniVar+IntToStr(RFx),''))
      then RFRecentFiles.Add(RFIni.ReadString(RFIniSection,RFIniVar+IntToStr(RFx),''));
   end;
{FIN DE: "Chercher les derniers Fichiers."}
{Remplir les Items.}
RFFaireLeMenu;
end;

{Mthode: Ajouter un nom de fichier dans le menu.}
Procedure TRecentFiles.AddFile(TheFile:String);
var
RFx:Integer;
begin
   if RFMenuProp=Nil then Exit;
RFx:=RFRecentFiles.IndexOf(TheFile);
   {Si ce nom n'est PAS dans la liste, on l'ajoute..}
   if (RFx=-1)then
   begin
   RFRecentFiles.Add(TheFile);
   RFx:=RFRecentFiles.Count-1;
   end;
{Mise en haut de la liste.}
RFRecentFiles.Move(RFx,0);
   {Si il y a 6 Noms de fichiers, on suprime le dernier.}
   if RFRecentFiles.Count>5
   then RFRecentFiles.Delete(5);
{Ecrire dans le Menu.}
RFFaireLeMenu;
   {Checker le 1er Item.}
   {Je sais pas si c'est une bonne ide !!!}
   If Not RFRecent1.Checked
   then RFRecent1.Checked:=true;
end;

{Ecire dans les Items ce qu'il faut.}
Procedure TRecentFiles.RFFaireLeMenu;
   {Ecrire l'Item et le montrer.}
   Procedure Lefaire(Objet:TObject;y:Integer);
   Begin
   TMenuItem(Objet).Caption:=RFRecentFiles[y];
   TMenuItem(Objet).Visible:=True
   end;
begin
{On cache TOUT...}
RFSepar1.Visible:=False;
RFRecent1.Visible:=False;
RFRecent2.Visible:=False;
RFRecent3.Visible:=False;
RFRecent4.Visible:=False;
RFRecent5.Visible:=False;
   {Si il y a des fichiers  mettre...}
   if RFRecentFiles.Count>0 then
   begin
   {Montrer le sparateur..}
   RFSepar1.Visible:=True;
      {Aller crire dans l'Item..}
      if RFRecentFiles.Count>0
      then LeFaire(RFRecent1,0);
      if RFRecentFiles.Count>1
      then LeFaire(RFRecent2,1);
      if RFRecentFiles.Count>2
      then LeFaire(RFRecent3,2);
      if RFRecentFiles.Count>3
      then LeFaire(RFRecent4,3);
      if RFRecentFiles.Count>4
      then LeFaire(RFRecent5,4);
   end;
end;

{Enregistrer les noms de fichiers dans le fichier INI.}
Procedure TRecentFiles.SaveNames;
Var RFx:Integer;
Begin
   if RFMenuProp=Nil then Exit;
   If (RFIniName<>'')
   and(Not (csDesigning in componentstate))then
   Begin
   {Effacer la liste DEJA ECRITE.}
   RFIni.EraseSection(RFIniSection);
      {Enregistrer la liste des noms de fichiers...}
      For RFx:=0 to RFRecentFiles.Count-1 do
      begin
         {...Uniquement si le fichier EXISTE !!!}
         if FileExists(RFRecentFiles[RFx])
         then RFIni.WriteString(RFIniSection,RFIniVar+IntToStr(RFx),RFRecentFiles[RFx]);
      end;
   end;
end;

{Click sur un des noms de fichier...}
procedure TRecentFiles.RFExec(Sender:TObject);
Var RFs:String;
begin
RFs:='';
   {Si le fichier de rfrence EXISTE...}
   if FileExists(TMenuItem(Sender).Caption)then
   begin
   RFs:=TMenuItem(Sender).Caption;
   {Le mettre en tte de liste.}
   AddFile(RFs);
   end
   else
   {...Sinon, des fois que l'utilisateur ait SUPPRIME ou DEPLACE
   le fichier pendant que le logiciel tournait... (Y a pas ide !!!)}
   begin
   MessageBeep(0);
   RFRecentFiles.Delete(TMenuitem(Sender).Tag);
   RFFaireLeMenu;
   end;
   {Si RFs='' Le fichier n'existe plus !!!}
   if Assigned(RFClick)
   Then RFClick(RFs);
end;

procedure Register;
begin
  RegisterComponents('Mezou', [TRecentFiles]);
end;

end.
 